﻿///////////////////////////////////////////////////////////////////////////////////////////////////
//
//  Copyright (c) 2007 Alexander Inochkin.  All rights reserved.
//
///////////////////////////////////////////////////////////////////////////////////////////////////

var alarmTime = null;
var alarmTimerId = null;

function initTimeReminder()
{
    setButton.innerText = _setButtonText;   

    System.Gadget.Flyout.file = "timeFlyout.html";
    setTimeout(clockTimer, 1000);
}

function clockTimer()
{
    if(alarmTime == null && alarmBellId == null)
    {
        dispalyHourTime(new Date());
    }
    setTimeout(clockTimer, 1000);
}

function dispalyHourTime(time)
{
    displayMinutesH.src = imagePath + Math.floor(time.getHours()/10) + imageSuffix;
    displayMinutesL.src = imagePath + Math.floor(time.getHours()%10) + imageSuffix;
    if( time.getSeconds() % 2 == 0 )
        displaySplitter.src = imagePath + "N" + imageSuffix;
    else
        displaySplitter.src = imagePath + "M" + imageSuffix;
    displaySecondsH.src = imagePath + Math.floor(time.getMinutes()/10) + imageSuffix;
    displaySecondsL.src = imagePath + Math.floor(time.getMinutes()%10) + imageSuffix;
}

function timerProcedure()
{
    if(alarmTime != null && showTimeLeft(alarmTime))
    {
        alarmTimerId = setTimeout(timerProcedure, 900);
    }
    else
        alarmTimerId = null;
}


function showTimeLeft(time)
{
    var diffTime = time - new Date();
    if( diffTime > 1 )
    {
        dispalyTime(new Date(diffTime));
        return true;
    }
    else
    {
        alarmTime = null;
        startAlarmBell();
        clearDisplay();
        return false;
    }
} 


var imagePath = "images/dig", imageSuffix = ".png";

function addMinutes(date, minutes)
{
    var result = new Date();
    result.setDate(date.getDate());
    result.setTime(date.getTime());
    result.setMinutes(result.getMinutes() + minutes);
    return result;
}

function clearDisplay()
{
    var src = imagePath + "D" + imageSuffix;
    displayMinutesH.src = src;
    displayMinutesL.src = src;
    displaySplitter.src = imagePath + "N" + imageSuffix;;
    displaySecondsH.src = src;
    displaySecondsL.src = src;
}
function dispalyTime(time)
{
    displayMinutesH.src = imagePath + Math.floor(time.getMinutes()/10) + imageSuffix;
    displayMinutesL.src = imagePath + Math.floor(time.getMinutes()%10) + imageSuffix;
    displaySplitter.src = imagePath + "M" + imageSuffix;
    displaySecondsH.src = imagePath + Math.floor(time.getSeconds()/10) + imageSuffix;
    displaySecondsL.src = imagePath + Math.floor(time.getSeconds()%10) + imageSuffix;
}



var mainPanelHideTimer = null;

function mainPanelMouseOver()
{
    setButton.style.backgroundImage = "url(images/setpanel_h.png)";
    setButton.style.color = "#ffa500";
    setButton.style.display = "block";
    
    if( mainPanelHideTimer != null )
    {
        clearTimeout(mainPanelHideTimer);
        mainPanelHideTimer = null;
    }
}
function mainPanelMouseOut()
{
    setButton.style.backgroundImage = "url(images/setpanel_o.png)";
    setButton.style.color = "#ffffff";
    if( mainPanelHideTimer != null )
        clearTimeout(mainPanelHideTimer);
    mainPanelHideTimer = setTimeout(hideSetButtonCallback, 1000); 
}

function hideSetButtonCallback()
{
    mainPanelHideTimer = null;
    setButton.style.display = "none";
}

function setButtonClick()
{
    System.Gadget.Flyout.show = !System.Gadget.Flyout.show;
}

var alarmBellId = null;
function startAlarmBell()
{
    if( alarmBellId != null )
        clearTimeout(alarmBellId);
        
    alarmBellId = setTimeout(clearAlarmBell, 7000);
    showAlarmBell();
}
function clearAlarmBell()
{
    if(alarmBellId != null)
        clearTimeout(alarmBellId);
    alarmBellId = null;
    hideAlarmBell();
}
function showAlarmBell()
{
    bellSound.src = "sound/bell.wav";
    bellPanel.style.display = "block";
    setButton.style.display = "none";
    mainPanel.style.display = "none";
}

function hideAlarmBell()
{
    bellPanel.style.display = "none";
    setButton.style.display = "none";
    mainPanel.style.display = "block";
}

function bellPanelClick()
{
    clearAlarmBell();
    bellSound.src = null;
}


function setAlarmTime(time)
{
    alarmTime = addMinutes(new Date(), time);
    if( alarmTimerId == null )
        alarmTimerId = setTimeout(timerProcedure, 0);
    else
    {
        if( alarmBellId != null )
        {
            clearAlarmBell();    
            bellSound.src = null;
        }
        showTimeLeft(alarmTime);
    }
}
function resetAlarmTime()
{
    alarmTime = null
    if( alarmTimerId != null )
        alarmTimerId = setTimeout(timerProcedure, 0);
    if( alarmBellId != null )
    {
        clearAlarmBell();    
        bellSound.src = null;
    }
    clearDisplay();
}